/*
 * 
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package entities;

import java.io.Serializable;
import java.util.List;
import javax.persistence.*;

/**
 *
 * @author Maeva
 */
@Entity
@NamedQueries({
    @NamedQuery(name = "Album.findAll", query = "SELECT a FROM Album a order by a.album_titre"),
    @NamedQuery(name = "Album.chercheAlbumDansRep", query = "SELECT a FROM Album a where a.album_repertoire.repertoire_id=:rep"),
    @NamedQuery(name = "Album.chercheParTitre", query = "SELECT a FROM Album a WHERE UPPER(a.album_titre)=UPPER(:titreAlbum)"),
    @NamedQuery(name = "Album.searchAll", query = "SELECT distinct a FROM Album a WHERE UPPER(a.album_titre) LIKE UPPER(:titreAlbum) order by a.album_titre"),
    @NamedQuery(name = "Album.findAllChansons", query = "SELECT c FROM Album a, Chanson c WHERE c.chanson_album.album_id=a.album_id and c.chanson_album=:album order by c.chanson_numeroTrack"),
    @NamedQuery(name = "Album.listeAlbumsDUneCategorie", query = "SELECT distinct a from Album a, Chanson c where c.chanson_album.album_id=a.album_id and c.chanson_genre=:genre order by a.album_titre"),
    @NamedQuery(name = "Album.commentairesDUnAlbum", query = "SELECT a.album_commentaires FROM Album a where a.album_id=:album_id")})
public class Album implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name="ALBUM_ID")
    private Long album_id;
    
    private String album_titre;

    private String album_couverture;

    @ManyToOne
    @JoinColumn(name="ARTISTE_ID")
    private Artiste album_artiste;
    
    @OneToMany(mappedBy="chanson_album", cascade = CascadeType.ALL,fetch= FetchType.LAZY)
    private List<Chanson> album_chansons;
    
    @OneToMany(mappedBy="comment_album", cascade = CascadeType.ALL)
    private List<Commentaire> album_commentaires;
    
    @ManyToOne
    @JoinColumn(name="REPERTOIRE_ID")
    private Repertoire album_repertoire;
    
    public Album()
    {
        
    }
    
    public Album(String titre, Artiste artiste, Repertoire r)
    { 
        this.album_titre=titre;
        this.album_artiste=artiste;
        this.album_repertoire=r;
    }

    public Long getalbum_Id() {
        return album_id;
    }

    public void setalbum_Id(Long id) {
        this.album_id = id;
    }
        public Artiste getAlbum_artiste() {
        return album_artiste;
    }
    
        public List<Chanson> getAlbum_chansons() {
        return album_chansons;
    }


    public String getAlbum_titre() {
        return album_titre;
    }
    

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (album_id != null ? album_id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Album)) {
            return false;
        }
        Album other = (Album) object;
        if ((this.album_id == null && other.album_id != null) || (this.album_id != null && !this.album_id.equals(other.album_id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        String a="entities.Album[ id=" + album_id + " + ";
        for(int i=0;i<album_chansons.size();i++){
            a+=" - "+album_chansons.get(i).getChanson_titre();
        }
        a+=" ]";
        return a;
    }

    public List<Commentaire> getAlbum_commentaires() {
        return album_commentaires;
    }

    public void setAlbum_commentaires(List<Commentaire> album_commentaires) {
        this.album_commentaires = album_commentaires;
    }

    public String getAlbum_couverture() {
        return album_couverture;
    }

    public void setAlbum_couverture(String album_couverture) {
        this.album_couverture = album_couverture;
    }

    public Repertoire getAlbum_repertoire() {
        return album_repertoire;
    }

    public void setAlbum_repertoire(Repertoire album_repertoire) {
        this.album_repertoire = album_repertoire;
    }
    
}
