/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package entities;

import java.io.Serializable;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.persistence.*;
import sessionbeans.GestionnaireArtiste;

/**
 *
 * @author Maeva
 */
@Entity
@NamedQueries({
    @NamedQuery(name = "Artiste.findAll", query = "SELECT a FROM Artiste a"),
    @NamedQuery(name = "Artiste.chercheParNom", query = "SELECT a FROM Artiste a WHERE UPPER(a.artiste_nom)=UPPER(:nomArtiste)"),
    @NamedQuery(name = "Artiste.findAllAlbums", query = "SELECT a FROM Album a, Artiste b WHERE a.album_artiste= :artiste")})
public class Artiste implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name="ARTISTE_ID")
    private Long artiste_id;
    private String artiste_nom;
    
    @OneToMany(mappedBy="chanson_artiste", cascade = CascadeType.ALL, fetch= FetchType.LAZY)
    private List<Chanson> artiste_chansons;
    
    @OneToMany(mappedBy="album_artiste", cascade = CascadeType.ALL, fetch= FetchType.LAZY)
    private List<Album> artiste_albums;
    
    public Artiste()
    {
        
    }
    
    public Artiste(String nom)
    {
        this.artiste_nom=nom;
    }

    public Long getartiste_Id() {
        return artiste_id;
    }

    public void setartiste_Id(Long id) {
        this.artiste_id = id;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (artiste_id != null ? artiste_id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Artiste)) {
            return false;
        }
        Artiste other = (Artiste) object;
        if ((this.artiste_id == null && other.artiste_id != null) || (this.artiste_id != null && !this.artiste_id.equals(other.artiste_id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "entities.Artiste[ id=" + artiste_id + " ]";
    }

    public String getArtiste_nom() {
        return artiste_nom;
    }

    public void setArtiste_nom(String artiste_nom) {
        this.artiste_nom = artiste_nom;
    }

    public List<Chanson> getArtiste_chansons() {
        return artiste_chansons;
    }

    public void setArtiste_chansons(List<Chanson> artiste_chansons) {
        this.artiste_chansons = artiste_chansons;
    }

    public List<Album> getArtiste_albums() {
        return artiste_albums;
    }

    public void setArtiste_albums(List<Album> artiste_albums) {
        this.artiste_albums = artiste_albums;
    }
    
}
