/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package entities;

import java.io.Serializable;
import java.util.List;
import javax.persistence.*;

/**
 *
 * @author Maeva
 */
@Entity
@NamedQueries({
    @NamedQuery(name = "Chanson.findAll", query = "SELECT c FROM Chanson c"),
    @NamedQuery(name = "Chanson.chercheToutesCategories", query = "SELECT distinct c.chanson_genre from Chanson c order by c.chanson_genre"),
    @NamedQuery(name = "Chanson.searchAll", query = "SELECT distinct c FROM Chanson c WHERE UPPER(c.chanson_titre) LIKE UPPER(:titreChanson) order by c.chanson_titre"),
    @NamedQuery(name = "Chanson.listeChansonsDUneCategorie", query = "SELECT c from Chanson c where c.chanson_genre=:genre order by c.chanson_titre")})
public class Chanson implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name="CHANSON_ID")
    private Long chanson_id;
    
    private String chanson_titre;
    private int chanson_numeroTrack;
    private String chanson_genre;
    private int chanson_annee;
    private String chanson_paroles;
    private String chanson_nom_fichier;

    
    @ManyToOne
    @JoinColumn(name="ARTISTE_ID")
    private Artiste chanson_artiste;
    
    @ManyToOne
    @JoinColumn(name="ALBUM_ID")
    private Album chanson_album;
    
    @ManyToOne
    @JoinColumn(name="REPERTOIRE_ID")
    private Repertoire chanson_repertoire;
    
//    @ManyToMany(mappedBy="playlist_chansons", cascade = CascadeType.PERSIST)
//    private List<Playlist> chanson_liste_playlists;
    
    @OneToMany(mappedBy="chanson")
    private List<AssociationChansonsPlaylists> playlists;
    
    public Chanson()
    {
        
    }
    
    // sans les paroles
    public Chanson(String titre, Artiste artiste, Album album, int numeroTrack, String genre, int annee,String nomfichier, Repertoire rep)
    {
        this.chanson_titre=titre;
        this.chanson_artiste=artiste;
        this.chanson_album=album;
        this.chanson_numeroTrack=numeroTrack;
        this.chanson_genre=genre;
        this.chanson_annee=annee;
        this.chanson_repertoire=rep;
        this.chanson_nom_fichier=nomfichier;
    }
    
    // avec les paroles
    public Chanson(String titre, Artiste artiste, Album album, int numeroTrack, String genre, int annee, String lyrics,String nomfichier, Repertoire rep)
    {
        this.chanson_titre=titre;
        this.chanson_artiste=artiste;
        this.chanson_album=album;
        this.chanson_numeroTrack=numeroTrack;
        this.chanson_genre=genre;
        this.chanson_annee=annee;
        this.chanson_repertoire=rep;
        this.chanson_paroles=lyrics;
        this.chanson_nom_fichier=nomfichier;
    }
    
    public void addChansonPlaylist(Playlist playlist){
        
    }

    public String getCheminComplet()
    {
        String bla = this.chanson_repertoire.getRepertoire_chemin()+"/"+chanson_nom_fichier;
        return bla.replace("\\", "/");
    }
    
    public Long getchanson_Id() {
        return chanson_id;
    }

    public void setchanson_Id(Long id) {
        this.chanson_id = id;
    }

    public String getChanson_nom_fichier() {
        return chanson_nom_fichier;
    }

    public void setChanson_nom_fichier(String chanson_nom_fichier) {
        this.chanson_nom_fichier = chanson_nom_fichier;
    }
    
    

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (chanson_id != null ? chanson_id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Chanson)) {
            return false;
        }
        Chanson other = (Chanson) object;
        if ((this.chanson_id == null && other.chanson_id != null) || (this.chanson_id != null && !this.chanson_id.equals(other.chanson_id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "entities.Chanson[ id=" + chanson_id + " ]";
    }

    public int getChanson_numeroTrack() {
        return chanson_numeroTrack;
    }

    public void setChanson_numeroTrack(int chanson_numeroTrack) {
        this.chanson_numeroTrack = chanson_numeroTrack;
    }

    public String getChanson_genre() {
        return chanson_genre;
    }

    public void setChanson_genre(String chanson_genre) {
        this.chanson_genre = chanson_genre;
    }

    public int getChanson_annee() {
        return chanson_annee;
    }

    public void setChanson_annee(int chanson_annee) {
        this.chanson_annee = chanson_annee;
    }

    public Artiste getChanson_artiste() {
        return chanson_artiste;
    }

    public void setChanson_artiste(Artiste chanson_artiste) {
        this.chanson_artiste = chanson_artiste;
    }

    public Album getChanson_album() {
        return chanson_album;
    }

    public void setChanson_album(Album chanson_album) {
        this.chanson_album = chanson_album;
    }

    public Repertoire getChanson_repertoire() {
        return chanson_repertoire;
    }

    public void setChanson_repertoire(Repertoire chanson_repertoire) {
        this.chanson_repertoire = chanson_repertoire;
    }

    public String getChanson_titre() {
        return chanson_titre;
    }

    public void setChanson_titre(String chanson_titre) {
        this.chanson_titre = chanson_titre;
    }
    
    public String getChanson_paroles() {
        return chanson_paroles;
    }

    public void setChanson_paroles(String chanson_paroles) {
        this.chanson_paroles = chanson_paroles;
    }
    

    public List<AssociationChansonsPlaylists> getPlaylists() {
        return playlists;
    }

    public void setPlaylists(List<AssociationChansonsPlaylists> playlists) {
        this.playlists = playlists;
    }
   
    
}
