/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package entities;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.*;

/**
 *
 * @author Maeva
 */
@Entity
@NamedQueries({
    @NamedQuery(name = "Commentaire.commentaireUserPourAlbum", query = "select distinct c from Commentaire c where c.comment_album=:album and c.comment_utilisateur=:user")})
public class Commentaire implements Serializable {
 
    private static long serialVersionUID = 1L;

    public static long getSerialVersionUID() {
        return serialVersionUID;
    }

    public static void setSerialVersionUID(long aSerialVersionUID) {
        serialVersionUID = aSerialVersionUID;
    }
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name="COMMENT_ID")
    private int comment_id;

    @ManyToOne
    @JoinColumn(name="UTILISATEUR_ID")
    private Utilisateur comment_utilisateur;

    @ManyToOne
    @JoinColumn(name="ALBUM_ID")
    private Album comment_album;

    @Temporal(javax.persistence.TemporalType.DATE)
    private Date comment_date;
    private String comment_texte;
    private int comment_note;

    public Commentaire()
    {
    }

    public Commentaire(Utilisateur user, Album album, Date date, String texte, int note)
    {
        this.comment_utilisateur=user;
        this.comment_album=album;
        this.comment_date=date;
        this.comment_texte=texte;
        this.comment_note=note;
    }

    public int getId() {
        return comment_id;
    }

    public void setId(int id) {
        this.comment_id = id;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (int) comment_id;
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the comment_id fields are not set
        if (!(object instanceof Commentaire)) {
            return false;
        }
        Commentaire other = (Commentaire) object;
        if (this.comment_id != other.comment_id) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "modeles.Commentaire[id=" + comment_id + "]";
    }

    public Utilisateur getComment_utilisateur() {
        return comment_utilisateur;
    }

    public void setComment_utilisateur(Utilisateur comment_utilisateur) {
        this.comment_utilisateur = comment_utilisateur;
    }

    public Album getComment_album() {
        return comment_album;
    }

    public void setComment_album(Album comment_album) {
        this.comment_album = comment_album;
    }

    public Date getComment_date() {
        return comment_date;
    }

    public void setComment_date(Date comment_date) {
        this.comment_date = comment_date;
    }

    public String getComment_texte() {
        return comment_texte;
    }

    public void setComment_texte(String comment_texte) {
        this.comment_texte = comment_texte;
    }

    public int getComment_note() {
        return comment_note;
    }

    public void setComment_note(int comment_note) {
        this.comment_note = comment_note;
    }

    
    
}
