/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package entities;

import java.io.Serializable;
import java.util.List;
import javax.persistence.*;

/**
 *
 * @author Maeva
 */
@Entity
@NamedQueries({
    @NamedQuery(name = "Playlist.playlistsUser", query = "SELECT p FROM Playlist p where p.playlist_utilisateur=:user"),
    @NamedQuery(name = "Playlist.chansonsPlaylist", query = "SELECT p FROM AssociationChansonsPlaylists p where p.playlist_id=:playlist_id order by p.position_chanson_dans_playlist"),
    @NamedQuery(name = "Playlist.findPlaylist", query = "SELECT p FROM Playlist p where p.playlist_id=:playlist_id"),
    @NamedQuery(name = "Playlist.nbChansons", query = "SELECT count(a) FROM Playlist p, AssociationChansonsPlaylists a where p.playlist_id=a.playlist_id and p=:playlist"),
    @NamedQuery(name = "Playlist.supprimePlaylist", query = "DELETE from Playlist p where p.playlist_id=:playlist_id")})
public class Playlist implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name="PLAYLIST_ID")
    private Long playlist_id;
    
    private String playlist_nom;
    
    @ManyToOne
    @JoinColumn(name="utilisateur_id")
    private Utilisateur playlist_utilisateur;

    @OneToMany(mappedBy="playlist")
    private List<AssociationChansonsPlaylists> chansons;
    
    public Playlist()
    {
        
    }
    
    public Playlist(String titre, Utilisateur user)
    {
        this.playlist_nom=titre;
        this.playlist_utilisateur=user;
    }
    
    public Long getId() {
        return playlist_id;
    }

    public void setId(Long id) {
        this.playlist_id = id;
    }
    
    public void addChanson(Chanson c,int pos){
        AssociationChansonsPlaylists a=new AssociationChansonsPlaylists(this,c,pos);
        this.chansons.add(a);//modif
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (playlist_id != null ? playlist_id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Playlist)) {
            return false;
        }
        Playlist other = (Playlist) object;
        if ((this.playlist_id == null && other.playlist_id != null) || (this.playlist_id != null && !this.playlist_id.equals(other.playlist_id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "entities.Playlist[ id=" + playlist_id + " ]";
    }

    public Utilisateur getPlaylist_proprietaire() {
        return playlist_utilisateur;
    }

    public void setPlaylist_proprietaire(Utilisateur playlist_proprietaire) {
        this.playlist_utilisateur = playlist_proprietaire;
    }

    public String getPlaylist_nom() {
        return playlist_nom;
    }

    public void setPlaylist_nom(String playlist_nom) {
        this.playlist_nom = playlist_nom;
    }

    public List<AssociationChansonsPlaylists> getChansons() {
        return chansons;
    }

    public void setChansons(List<AssociationChansonsPlaylists> chansons) {
        this.chansons = chansons;
    }

    
}
