/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package entities;

import java.io.Serializable;
import java.util.List;
import javax.persistence.*;

/**
 *
 * @author Maeva
 */
@Entity
@NamedQueries({
    @NamedQuery(name = "Repertoire.findAll", query = "SELECT r FROM Repertoire r"),
    @NamedQuery(name = "Repertoire.chercheParChemin", query = "SELECT r FROM Repertoire r WHERE r.repertoire_chemin = :chemin"),
@NamedQuery(name = "Repertoire.chercheCeuxSansParent", query = "SELECT r FROM Repertoire r WHERE r.repertoire_pere IS NULL"),
@NamedQuery(name = "Repertoire.chercheFils", query = "SELECT r FROM Repertoire r WHERE r.repertoire_pere.repertoire_nom=:idrep")})


public class Repertoire implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name="REPERTOIRE_ID")
    private Long repertoire_id;
    
    private String repertoire_nom;
    private String repertoire_chemin;
    
    @OneToMany(mappedBy = "repertoire_pere", cascade = CascadeType.ALL)
    private List<Repertoire> repertoire_fils;
    @OneToMany(mappedBy = "chanson_repertoire", cascade = CascadeType.ALL)
    private List<Chanson> repertoire_chansons;
    
    @ManyToOne
    @JoinColumn(name="REPERTOIRE_PARENT_ID")
    private Repertoire repertoire_pere;
    
    @OneToMany(mappedBy="album_repertoire", cascade = CascadeType.ALL)
    private List<Album> repertoire_albums;
      
    public Repertoire()
    {
        
    }
    
    public Repertoire(String nom, String chemin, Repertoire parent)
    {
        this.repertoire_nom=nom;
        this.repertoire_chemin=chemin;
        this.repertoire_pere=parent;
    }

    public Long getRepertoire_id() {
        return repertoire_id;
    }

    public void setRepertoire_id(Long repertoire_id) {
        this.repertoire_id = repertoire_id;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (repertoire_id != null ? repertoire_id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Repertoire)) {
            return false;
        }
        Repertoire other = (Repertoire) object;
        if ((this.repertoire_id == null && other.repertoire_id != null) || (this.repertoire_id != null && !this.repertoire_id.equals(other.repertoire_id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "entities.Repertoire[ id=" + repertoire_id + " ]";
    }

    public String getRepertoire_nom() {
        return repertoire_nom;
    }

    public void setRepertoire_nom(String repertoire_nom) {
        this.repertoire_nom = repertoire_nom;
    }

    public String getRepertoire_chemin() {
        return repertoire_chemin;
    }

    public void setRepertoire_chemin(String repertoire_chemin) {
        this.repertoire_chemin = repertoire_chemin;
    }

    public List<Repertoire> getRepertoire_fils() {
        return repertoire_fils;
    }

    public void setRepertoire_fils(List<Repertoire> repertoire_fils) {
        this.repertoire_fils = repertoire_fils;
    }

    public List<Chanson> getRepertoire_chansons() {
        return repertoire_chansons;
    }

    public void setRepertoire_chansons(List<Chanson> repertoire_chansons) {
        this.repertoire_chansons = repertoire_chansons;
    }

    public Repertoire getRepertoire_pere() {
        return repertoire_pere;
    }

    public void setRepertoire_pere(Repertoire repertoire_pere) {
        this.repertoire_pere = repertoire_pere;
    }

    public List<Album> getRepertoire_albums() {
        return repertoire_albums;
    }

    public void setRepertoire_albums(List<Album> repertoire_albums) {
        this.repertoire_albums = repertoire_albums;
    }
    
}
