/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package entities;

import java.io.Serializable;
import java.util.List;
import javax.persistence.*;

/**
 *
 * @author Maeva
 */
@Entity
@NamedQueries({
    @NamedQuery(name = "Utilisateur.connexion", query = "SELECT distinct u FROM Utilisateur u where u.utilisateur_email=:email")})
public class Utilisateur implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long utilisateur_id;
    
    private String utilisateur_nom, utilisateur_prenom, utilisateur_email, utilisateur_password;
    
    @OneToMany(mappedBy="playlist_utilisateur", cascade = CascadeType.ALL)
    private List<Playlist> utilisateur_playlists;
    
    @OneToMany(mappedBy="comment_utilisateur", cascade = CascadeType.ALL)
    private List<Commentaire> utilisateur_commentaires;
    
    public Utilisateur()
    {
        
    }

    public Utilisateur(String nom, String prenom, String email, String password)
    {
        this.utilisateur_nom=nom;
        this.utilisateur_prenom=prenom;
        this.utilisateur_email=email;
        this.utilisateur_password=password;
    }
      
    public void addPlaylist(Playlist p)
    {
        this.utilisateur_playlists.add(p);
    }
    
    public Long getId() {
        return utilisateur_id;
    }

    public void setId(Long id) {
        this.utilisateur_id = id;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (utilisateur_id != null ? utilisateur_id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Utilisateur)) {
            return false;
        }
        Utilisateur other = (Utilisateur) object;
        if ((this.utilisateur_id == null && other.utilisateur_id != null) || (this.utilisateur_id != null && !this.utilisateur_id.equals(other.utilisateur_id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "entities.Utilisateur[ id=" + utilisateur_id + " ]";
    }

    public String getUtilisateur_nom() {
        return utilisateur_nom;
    }

    public void setUtilisateur_nom(String utilisateur_nom) {
        this.utilisateur_nom = utilisateur_nom;
    }

    public String getUtilisateur_prenom() {
        return utilisateur_prenom;
    }

    public void setUtilisateur_prenom(String utilisateur_prenom) {
        this.utilisateur_prenom = utilisateur_prenom;
    }

    public String getUtilisateur_email() {
        return utilisateur_email;
    }

    public void setUtilisateur_email(String utilisateur_email) {
        this.utilisateur_email = utilisateur_email;
    }

    public String getUtilisateur_password() {
        return utilisateur_password;
    }

    public void setUtilisateur_password(String utilisateur_password) {
        this.utilisateur_password = utilisateur_password;
    }

    public List<Playlist> getUtilisateur_playlists() {
        return utilisateur_playlists;
    }

    public void setUtilisateur_playlists(List<Playlist> utilisateur_playlists) {
        this.utilisateur_playlists = utilisateur_playlists;
    }

    public List<Commentaire> getUtilisateur_commentaires() {
        return utilisateur_commentaires;
    }

    public void setUtilisateur_commentaires(List<Commentaire> utilisateur_commentaires) {
        this.utilisateur_commentaires = utilisateur_commentaires;
    }
    
}
