/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package sessionbeans;

import entities.Album;
import entities.Chanson;
import entities.Commentaire;
import entities.Repertoire;
import java.util.List;
import javax.ejb.Stateless;
import javax.ejb.LocalBean;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;


/**
 *
 * @author Maeva
 */
@Stateless
@LocalBean
public class GestionnaireAlbum {
 @PersistenceContext(unitName = "MusiqueANTOINE-MOPOLO-ejbPU")
    private EntityManager em;
 
    
    public void creerAlbum(Album a)
    {
        em.persist(a);
    }
        
     public Album chercheParRep(Repertoire rep) {
        Query query = em.createNamedQuery("Album.chercheAlbumDansRep");
        query.setParameter("rep", rep.getRepertoire_id());
        query.setMaxResults(1);
        Album a = null;
        try {
            a = (Album) query.getSingleResult();
        } catch (NoResultException e) {
            return null;
        }
        return a;
    }        
            
    public Album chercheParTitre(String titrealbum) {
        Query query = em.createNamedQuery("Album.chercheParTitre");
        query.setParameter("titreAlbum", titrealbum);
        Album a = null;
        try {
            a = (Album) query.getSingleResult();
        } catch (NoResultException e) {
            return null;
        }
        return a;
    }
    
    public List<Album> searchAll(String titrealbum) {
        Query query = em.createNamedQuery("Album.searchAll");
        query.setParameter("titreAlbum", titrealbum);
        return query.getResultList();
    }
    
    public List<Commentaire> getCommentairesDUnAlbum(Album a)
    {
        Query query = em.createNamedQuery("Album.commentairesDUnAlbum");
        query.setParameter("album_id", a.getalbum_Id());
        return query.getResultList();
    }
    
    public List<Album> getAllAlbums()
    {
        Query query = em.createNamedQuery("Album.findAll");
        return query.getResultList();
    }
    
    public List<Chanson> getAllAlbumChansons(Album album)
    {
        Query query = em.createNamedQuery("Album.findAllChansons");
        query.setParameter("album", album);
        return query.getResultList();
    }
    
    public List<Album> getAlbumsDUneCategorie(String genre)
    {
        Query query = em.createNamedQuery("Album.listeAlbumsDUneCategorie");
        query.setParameter("genre", genre);
        return query.getResultList();
    }
}
