/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package sessionbeans;

import entities.Artiste;
import entities.Album;
import java.util.List;
import javax.ejb.Stateless;
import javax.ejb.LocalBean;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

/**
 *
 * @author Maeva
 */
@Stateless
@LocalBean
public class GestionnaireArtiste {

    @PersistenceContext(unitName = "MusiqueANTOINE-MOPOLO-ejbPU")
    private EntityManager em;
    
    
    public void creerArtiste(Artiste a)
    {
        em.persist(a);
    }
    
    public Artiste chercheParNom(String nomartiste) {
        Query query = em.createNamedQuery("Artiste.chercheParNom");
        query.setParameter("nomArtiste", nomartiste);
        Artiste a = null;
        try {
            a = (Artiste) query.getSingleResult();
        } catch (NoResultException e) {
            return null;
        }
        return a;
    }
    
    public List<Artiste> getAllArtistes()
    {
        Query query = em.createNamedQuery("Artiste.findAll");
        return query.getResultList();
    }
    
    public List<Album> getAllArtisteAlbums(Artiste artiste)
    {
        Query query = em.createNamedQuery("Artiste.findAllAlbums");
        query.setParameter("artiste", artiste);
        return query.getResultList();
    }
    
}
