/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package sessionbeans;

import entities.AssociationChansonsPlaylists;
import entities.Chanson;
import entities.Playlist;
import entities.Utilisateur;
import java.util.List;
import javax.ejb.Stateless;
import javax.ejb.LocalBean;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

/**
 *
 * @author Maeva
 */
@Stateless
@LocalBean
public class GestionnairePlaylist{

    @PersistenceContext(unitName = "MusiqueANTOINE-MOPOLO-ejbPU")
    private EntityManager em;
   
    public void creerPlaylist(Playlist p)
    {
        em.persist(p);
    }
    
    public void addChanson(Playlist p, Chanson c)
    {
        System.out.println(p.getPlaylist_nom()+" "+c.getChanson_titre());
        int position=getNbChansonsDansPlaylist(p) + 1;
        p.addChanson(c,position);
        em.merge(p);//modif
    }
    
    public List<AssociationChansonsPlaylists> getChansonsPlaylist(Playlist p)
    {
        Query query = em.createNamedQuery("Playlist.chansonsPlaylist");
        System.out.println("Dans getChansonsPlaylist de GestionnairePlyalist "+p.getId());
        query.setParameter("playlist_id", p.getId());
        List<AssociationChansonsPlaylists> a=query.getResultList();
        System.out.println(a);
        return a;
    }
    
    public Playlist findPlaylist(long id){
        Query query = em.createNamedQuery("Playlist.findPlaylist");
        query.setParameter("playlist_id", id);
        return (Playlist) query.getSingleResult();
    }
    
    public void bougeChanson(Playlist p, Chanson c, int position, String changement)
    {
        if(changement.equals("monter"))
        {
            if(position > 1)
            {
                Query query = em.createNamedQuery("AssociationChansonsPlaylists.bougePositionChanson");
                query.setParameter("position", position-1);
                query.setParameter("new_position", position);
                query.executeUpdate();
                Query query2 = em.createNamedQuery("AssociationChansonsPlaylists.bougePositionChansonVoulue");
                query2.setParameter("chanson_id", c.getchanson_Id());
                query2.setParameter("playlist_id", p.getId());
                query2.setParameter("new_position", position-1);
                query2.executeUpdate();
            }
        }
        else if (changement.equals("descendre"))
        {
            if(position < getNbChansonsDansPlaylist(p))
            {
                Query query = em.createNamedQuery("AssociationChansonsPlaylists.bougePositionChanson");
                query.setParameter("position", position+1);
                query.setParameter("new_position", position);
                query.executeUpdate();
                Query query2 = em.createNamedQuery("AssociationChansonsPlaylists.bougePositionChansonVoulue");
                query2.setParameter("chanson_id", c.getchanson_Id());
                query2.setParameter("playlist_id", p.getId());
                query2.setParameter("new_position", position+1);
                query2.executeUpdate();
            }
        }
    }
    
    public AssociationChansonsPlaylists getAssociation(Playlist p, Chanson c)
    {
        Query query = em.createNamedQuery("AssociationChansonsPlaylists.findByChansonEtPlaylist");
        query.setParameter("playlist_id", p.getId());
        query.setParameter("chanson_id", c.getchanson_Id());
        return (AssociationChansonsPlaylists)(query.getSingleResult());
    }
    
    public void supprimeChansonDansPlaylist(Playlist p, Chanson c)
    {
        Query query1 = em.createNamedQuery("AssociationChansonsPlaylists.findPosition");
        query1.setParameter("playlist_id", p.getId());
        query1.setParameter("chanson_id", c.getchanson_Id());
        int position = Integer.parseInt(query1.getSingleResult().toString());        
                
        Query query = em.createNamedQuery("AssociationChansonsPlaylists.findNbChansonsDansPlaylist");
        query.setParameter("playlist_id", p.getId());
        int nbChansonsDansPlaylist = Integer.parseInt(query.getSingleResult().toString());
        
        Query query2 = em.createNamedQuery("AssociationChansonsPlaylists.supprimeChansonDansPlaylist");
        query2.setParameter("playlist_id", p.getId());
        query2.setParameter("chanson_id", c.getchanson_Id());
        query2.executeUpdate();
        
        // une fois la chanson supprimée il faut remonter d'une position toutes les chansons qui étaient en dessous d'elle
        Query query3 = em.createNamedQuery("AssociationChansonsPlaylists.bougePositionChanson");
        for (int i=position+1;i<nbChansonsDansPlaylist+1;i++)
        {
        query3.setParameter("position", i);
        query3.setParameter("new_position", i-1);
        query3.executeUpdate();
        }
    }
    
    public void supprimePlaylist(Playlist p)
    {
        Query query = em.createNamedQuery("AssociationChansonsPlaylists.supprimePlaylist");
        query.setParameter("playlist_id", p.getId());
        query.executeUpdate();
        Query query2 = em.createNamedQuery("Playlist.supprimePlaylist");
        query2.setParameter("playlist_id", p.getId());
        query2.executeUpdate();
    }
    
    public List<Playlist> getPlaylistsUser(Utilisateur u)
    {
        Query query = em.createNamedQuery("Playlist.playlistsUser");
        query.setParameter("user", u);
        return query.getResultList();
    }
    
    public int getNbChansonsDansPlaylist(Playlist p)
    {
        Query query = em.createNamedQuery("Playlist.nbChansons");
        query.setParameter("playlist", p);
        return Integer.parseInt(query.getSingleResult().toString());
    }
    
}
