/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package util;

import entities.*;
import java.awt.Image;
import java.io.File;
import java.io.IOException;
import java.io.Serializable;
import java.nio.CharBuffer;
import java.nio.charset.Charset;
import java.nio.charset.CharsetEncoder;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.ejb.EJB;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import org.farng.mp3.MP3File;
import org.farng.mp3.TagException;
import org.farng.mp3.id3.ID3v1;
import org.farng.mp3.id3.ID3v2_3;
import sessionbeans.GestionnaireAlbum;
import sessionbeans.GestionnaireArtiste;
import sessionbeans.GestionnaireChanson;
import sessionbeans.GestionnaireRepertoire;
import sessionbeans.*;


/**
 *
 * @author Maeva
 */
public class ExploreurDossiers implements Serializable {
    
    GestionnaireChanson gestionnaireChanson = lookupGestionnaireChansonBean();
    GestionnaireArtiste gestionnaireArtiste = lookupGestionnaireArtisteBean();
    GestionnaireAlbum gestionnaireAlbum = lookupGestionnaireAlbumBean();
    GestionnaireRepertoire gestionnaireRepertoire = lookupGestionnaireRepertoireBean();
    Album album=null;
    Repertoire repfils=null;
    public String chemin;
    
    private static ArrayList<String> genreString = new ArrayList<String>();

    public ExploreurDossiers()
    {
        
    }
    
    public ExploreurDossiers(String chemin)
    {
        this.chemin = chemin;
    }
    
    public void explore(String nomrep) throws IOException {
        System.out.println("je suis appele");
        Object m;
        File f = new File(nomrep);
        Repertoire r;
        try {
            r = gestionnaireRepertoire.chercheParChemin(nomrep);
        } catch (NullPointerException ne) {
            r = new Repertoire(f.getName(), f.getAbsolutePath(), null);
            gestionnaireRepertoire.creerRepertoire(r);
        }
 
        List<File> LMC = new ArrayList();
        File[] listFiles = f.listFiles();

        for (int i = 0; i < listFiles.length; i++) {
            if (listFiles[i].isDirectory()) {
                repfils = new Repertoire(listFiles[i].getName(), listFiles[i].getAbsolutePath(), r);
                gestionnaireRepertoire.creerRepertoire(repfils);
                // r.getRepertoire_fils().add(repfils);
                explore(repfils.getRepertoire_chemin());
            } else {
                LMC.add(listFiles[i]);
                System.out.println("nom du fichier" + listFiles[i].getName());

            }
        }

        for (int j = 0; j < LMC.size(); j++) {
            String nameFile = LMC.get(j).getName();
            
            if (nameFile.substring(nameFile.length() - 4, nameFile.length()).equals(".mp3")) {
                MP3File mp3file;
                
                
                try {
                    mp3file = new MP3File(LMC.get(j));
                }
                catch (Exception e) {
                    mp3file = null;
                }
                if (mp3file != null) {
                
                    
                    if (mp3file.hasID3v1Tag()) {
                        
                        
                        if (mp3file.hasID3v2Tag()) {
                            System.out.println("Je suis dans IPV2!!!!!");

                            ID3v2_3 id3v2Tag= (ID3v2_3) mp3file.getID3v2Tag();
                            if (id3v2Tag != null) {
                            System.out.println(id3v2Tag.getLeadArtist().replace("ÿþ", ""));
                            Artiste artiste = gestionnaireArtiste.chercheParNom(id3v2Tag.getLeadArtist().replace("ÿþ", ""));
                            if (artiste == null) {
                                if(id3v2Tag.getLeadArtist().equals(""))
                                {
                                    artiste = gestionnaireArtiste.chercheParNom("Artiste Inconnu");
                                    if (artiste==null)
                                    {
                                        artiste = new Artiste("Artiste Inconnu");
                                    }
                                    gestionnaireArtiste.creerArtiste(artiste);
                                }
                                else {
                                    String artistenom=id3v2Tag.getLeadArtist().replace("ÿþ", "");
                                     
                                artiste = new Artiste(artistenom);
                                gestionnaireArtiste.creerArtiste(artiste);
                                System.out.println("J'ai créé un artiste");
                                }
                            }
                            System.out.println(id3v2Tag.getAlbumTitle().replaceAll("ÿþ", "").replaceAll("^ÿ","~").replaceAll("û0", ".").replaceAll("Ë%","○").replaceAll("Ç", "χ").replaceAll("ÿ", "%").replaceAll("\"","∠").replace("\bi/$", "⑩").replaceAll("^%", "~"));
                            album = gestionnaireAlbum.chercheParTitre(id3v2Tag.getAlbumTitle().replaceAll("ÿþ", "").replaceAll("^ÿ","~").replaceAll("û0", ".").replaceAll("Ë%","○").replaceAll("Ç", "χ").replaceAll("ÿ", "%").replaceAll("\"","∠").replaceAll("i$", "⑩").replaceAll("^%", "~"));
                            if (album == null) {
                                album = new Album(id3v2Tag.getAlbumTitle().replaceAll("ÿþ", "").replaceAll("^ÿ","~").replaceAll("û0", ".").replaceAll("Ë%","○").replaceAll("Ç", "χ").replaceAll("ÿ", "%").replaceAll("\"","∠").replaceAll("i$", "⑩").replaceAll("^%", "~"), artiste, repfils);
                                gestionnaireAlbum.creerAlbum(album);
                                System.out.println("J'ai créé un album - suite : -"+id3v2Tag.getTrackNumberOnAlbum().replaceAll("/[0-9]+","")+"-");
                            }
                            String track = "0";
                            System.out.println("track reel : -"+id3v2Tag.getTrackNumberOnAlbum().replaceAll("ÿþ","").replaceAll("/[0-9]+","")+"-");
                            try {
                                if (!((id3v2Tag.getTrackNumberOnAlbum().replaceAll("ÿþ","").replaceAll("/[0-9]+","")).equals(""))) { 
                                    track = id3v2Tag.getTrackNumberOnAlbum().replaceAll("ÿþ","").replaceAll("/[0-9]+",""); 
                                    if(track.equals("00"))track="0";
                                    if(track.equals("01"))track="1";
                                    if(track.equals("02"))track="2";
                                    if(track.equals("03"))track="3";
                                    if(track.equals("04"))track="4";
                                    if(track.equals("05"))track="5";
                                    if(track.equals("06"))track="6";
                                    if(track.equals("07"))track="7";
                                    if(track.equals("08"))track="8";
                                    if(track.equals("09"))track="9";
                                }
                            } catch (UnsupportedOperationException e) {
                            }
                            String annee = "2000";  
                            try {
                                if (!((id3v2Tag.getYearReleased().replace("ÿþ", "")).equals(""))) {
                                    annee = id3v2Tag.getYearReleased().replace("ÿþ", "");
                                    annee=annee.replaceAll("\\s","");
                                    boolean annee2 = annee.matches("[0-9]+");
                                    Pattern p = Pattern.compile("\\d+"); // Ici ton regex => ta chaine de caractere a trouver
                                    Matcher ma = p.matcher(annee); // s ta chaine titi23àde
                                    annee="";
                                    while(ma.find())
                                    {
                                        annee=annee.concat(ma.group());
                                        System.out.println(annee);
                                    
                                    }
                                    
                                    if(annee.length()>4)
                                    {
                                        annee=annee.substring(0, 4);
                                    }
                                    
                                    System.out.println("annee : "+annee+" - "+annee2+" annee attendu : -"+(id3v2Tag.getYearReleased().replace("ÿþ", "")).replaceAll(" ","")+"-");
                                }
                            } catch (UnsupportedOperationException e) {
                            }
                            String title=id3v2Tag.getSongTitle().replaceAll("ÿþ", "").replaceAll("^ÿ","~").replaceAll("û0", ".").replaceAll("Ë%","○").replaceAll("Ç", "χ").replaceAll("ÿ", "%").replaceAll("\"","∠");
                            String lyrics;
                            
                            if(mp3file.hasLyrics3Tag())
                            {
                                lyrics = id3v2Tag.getSongLyric();
                            }
                            else
                            {
                                lyrics = null;
                            }
                            
                            System.out.println("lyrics : "+lyrics);
                            String genre=id3v2Tag.getSongGenre().replace("ÿþ", "");
                            System.out.println("MON GENRE EST "+genre);
                            if(genre.contains("(")){
                                genre= getGenreString(Integer.valueOf(mp3file.getID3v1Tag().getSongGenre()));
                            }
                            
                            gestionnaireChanson.creerChanson(new Chanson(title, artiste, album, Integer.valueOf(track),genre, Integer.valueOf(annee),lyrics,nameFile, r));
                            System.out.println(id3v2Tag.getYearReleased().replace("ÿþ", ""));
                            System.out.println(id3v2Tag.getSongGenre().replace("ÿþ", ""));
                            String trackNumString = "0";

                            try {
                                System.out.println(id3v2Tag.getTrackNumberOnAlbum().replace("ÿþ", ""));
                            } catch (UnsupportedOperationException e) {
                            }
                        }
                            
                        }
                        
                        else{
                            ID3v1 id3 = mp3file.getID3v1Tag();
                        
                        if (id3 != null) {
                            System.out.println(id3.getArtist());
                            Artiste artiste = gestionnaireArtiste.chercheParNom(id3.getArtist());
                            if (artiste == null) {
                                if(id3.getArtist().equals(""))
                                {
                                    artiste = gestionnaireArtiste.chercheParNom("Artiste Inconnu");
                                    if (artiste==null)
                                    {
                                        artiste = new Artiste("Artiste Inconnu");
                                    }
                                    gestionnaireArtiste.creerArtiste(artiste);
                                }
                                else {
                                artiste = new Artiste(id3.getArtist());
                                gestionnaireArtiste.creerArtiste(artiste);
                                }
                            }
                            
                            System.out.println(id3.getAlbum());
                            album = gestionnaireAlbum.chercheParTitre(id3.getAlbum());
                            if (album == null) {
                                album = new Album(id3.getAlbum(), artiste, repfils);
                                gestionnaireAlbum.creerAlbum(album);
                            }
                            String track = "0";
                            try {
                                if (!(id3.getTrackNumberOnAlbum().equals(""))) {
                                    track = id3.getTrackNumberOnAlbum();
                                }
                            } catch (UnsupportedOperationException e) {
                            }
                            String annee = "2000";
                            try {
                                if (!(id3.getYear().equals(""))) {
                                    annee = id3.getYear();
                                }
                            } catch (UnsupportedOperationException e) {
                            }
                            
                            String lyrics;
                            
                            if(mp3file.hasLyrics3Tag())
                            {
                                lyrics = id3.getSongLyric();
                            }
                            else
                            {
                                lyrics = null;
                            }
                            System.out.println("lyrics : "+lyrics);
                            gestionnaireChanson.creerChanson(new Chanson(id3.getSongTitle(), artiste, album, Integer.valueOf(track), getGenreString(Integer.valueOf(id3.getSongGenre())), Integer.valueOf(annee),lyrics,nameFile, r));
                            System.out.println(id3.getYear());
                            System.out.println(getGenreString(Integer.valueOf(id3.getSongGenre())));
                            String trackNumString = "0";

                            try {
                                System.out.println(id3.getTrackNumberOnAlbum());
                            } catch (UnsupportedOperationException e) {
                            }
                        }
                        }
                        
                    }
                }
            }
            if (nameFile.substring(nameFile.length() - 4, nameFile.length()).equals(".jpg") && nameFile.contains("Large")) {
                System.out.println("ALBUM " +album.getAlbum_titre()+ "et image = "+nameFile);
                if(album.getAlbum_couverture()==null)
                {
                album.setAlbum_couverture(nameFile);
                UploadImg.uploadimage(nameFile, album.getAlbum_repertoire().getRepertoire_chemin());
                }
            }
        }

        //List<String> liste = gestionnaireChanson.chercheToutesCategories();
        List<Album> liste = gestionnaireAlbum.getAllAlbums();
        for (int p = 0; p < liste.size(); p++) {
            if(liste.get(p).getAlbum_couverture()==null)
            {
                liste.get(p).setAlbum_couverture("couverturenondispo.jpg");
            }
        }
        
    }
    

    public static String getGenreString(int num) {
        if (genreString.isEmpty()) {
            genreString.add(0, "Blues");
            genreString.add(1, "Classic rock");
            genreString.add(2, "Country");
            genreString.add(3, "Dance");
            genreString.add(4, "Disco");
            genreString.add(5, "Funk");
            genreString.add(6, "Grunge");
            genreString.add(7, "Hip-Hop");
            genreString.add(8, "Jazz");
            genreString.add(9, "Metal");
            genreString.add(10, "New Age");
            genreString.add(11, "Oldies");
            genreString.add(12, "Autre");
            genreString.add(13, "Pop");
            genreString.add(14, "R'n'B");
            genreString.add(15, "Rap");
            genreString.add(16, "Raggae");
            genreString.add(17, "Rock");
            genreString.add(18, "Techno");
            genreString.add(19, "Musique industrielle");
            genreString.add(20, "Rock Alternatif (Alternative)");
            genreString.add(21, "Ska");
            genreString.add(22, "Death Metal");
            genreString.add(23, "Pranks");
            genreString.add(24, "Musique de Film");
            genreString.add(25, "Euro-Techno");
            genreString.add(26, "Ambient");
            genreString.add(27, "Trip-hop");
            genreString.add(28, "Musique Vocale");
            genreString.add(29, "Jazz-Funk");
            genreString.add(30, "Fusion");
            genreString.add(31, "Trance");
            genreString.add(32, "Musique Classique");
            genreString.add(33, "Instrumental");
            genreString.add(34, "Acid");
            genreString.add(35, "House");
            genreString.add(36, "Musique de Jeux-vidéo");
            genreString.add(37, "Extrait Sonore");
            genreString.add(38, "Gospel");
            genreString.add(39, "Musique bruitiste");
            genreString.add(40, "Rock alternatif");
            genreString.add(41, "Bass");
            genreString.add(42, "Soul");
            genreString.add(43, "Punk");
            genreString.add(44, "Space");
            genreString.add(45, "Musique de médiation (Meditative)");
            genreString.add(46, "Pop instrumental");
            genreString.add(47, "Rock instrumental");
            genreString.add(48, "Musique ethnique");
            genreString.add(49, "Gothique");
            genreString.add(50, "Darkwave");
            genreString.add(51, "Techno-Industrial");
            genreString.add(52, "Musique électronique");
            genreString.add(53, "Pop-Folk");
            genreString.add(54, "Eurodance");
            genreString.add(55, "Dream");
            genreString.add(56, "Rock sudiste (Southern Rock)");
            genreString.add(57, "Comédie");
            genreString.add(58, "Morceau \"culte\" (Cult)");
            genreString.add(59, "Gangsta");
            genreString.add(60, "Hit-parade");
            genreString.add(61, "Rap chrétien (Christian Rap)");
            genreString.add(62, "Pop/Funk");
            genreString.add(63, "Jungle");
            genreString.add(64, "Musique amérindienne");
            genreString.add(65, "Cabaret");
            genreString.add(66, "New wave");
            genreString.add(67, "Psychédélique");
            genreString.add(68, "Rave");
            genreString.add(69, "Comédie musicale (Showtunes)");
            genreString.add(70, "Bande-annonce");
            genreString.add(71, "Lo-fi");
            genreString.add(72, "Musique tribale");
            genreString.add(73, "Acid Punk");
            genreString.add(74, "Acid Jazz");
            genreString.add(75, "Polka");
            genreString.add(76, "Rétro");
            genreString.add(77, "Théâtre");
            genreString.add(78, "Rock & Roll");
            genreString.add(79, "Hard Rock");
            genreString.add(80, "Folk");
            genreString.add(81, "Folk rock");
            genreString.add(82, "Folk américain");
            genreString.add(83, "Swing");
            genreString.add(84, "Fast Fusion");
            genreString.add(85, "Bebop");
            genreString.add(86, "Musique latine");
            genreString.add(87, "Revival");
            genreString.add(88, "Musique celtique");
            genreString.add(89, "Bluegrass");
            genreString.add(90, "Avantgarde");
            genreString.add(91, "Gothic Rock");
            genreString.add(92, "Rock progressif");
            genreString.add(93, "Rock psychédélique");
            genreString.add(94, "Rock symphonique");
            genreString.add(95, "Slow Rock");
            genreString.add(96, "Big Band");
            genreString.add(97, "Chœur");
            genreString.add(98, "Easy listening");
            genreString.add(99, "Acoustic (Acoustique)");
            genreString.add(100, "Humour");
            genreString.add(101, "Discours (Speech)");
            genreString.add(102, "Chanson");
            genreString.add(103, "Opéra");
            genreString.add(104, "Musique de chambre");
            genreString.add(105, "Sonate");
            genreString.add(106, "Symphonie");
            genreString.add(107, "Booty Bass");
            genreString.add(108, "Primus");
            genreString.add(109, "Porn groove");
            genreString.add(110, "Satire");
            genreString.add(111, "R'n'B contemporain");
            genreString.add(112, "Club");
            genreString.add(113, "Tango");
            genreString.add(114, "Samba");
            genreString.add(115, "Folklore");
            genreString.add(116, "Ballade");
            genreString.add(117, "Power ballad");
            genreString.add(118, "Rythmic soul");
            genreString.add(119, "Freestyle");
            genreString.add(120, "Duo");
            genreString.add(121, "Punk rock");
            genreString.add(122, "Drum Solo (solo de batterie)");
            genreString.add(123, "A cappella");
            genreString.add(124, "Euro-house");
            genreString.add(125, "Dancehall");
            genreString.add(126, "Goa");
            genreString.add(127, "Drum and bass");
            genreString.add(128, "Club House");
            genreString.add(129, "Hardcore");
            genreString.add(130, "Terror");
            genreString.add(131, "Indie");
            genreString.add(132, "BritPop");
            genreString.add(133, "BritPop");
            genreString.add(134, "Polsk Punk");
            genreString.add(135, "Beat");
            genreString.add(136, "Gangsta rap chrétien");
            genreString.add(137, "Heavy metal");
            genreString.add(138, "Black metal");
            genreString.add(139, "Crossover");
            genreString.add(140, "Musique chrétienne contemporaine");
            genreString.add(141, "Rock chrétien");
            genreString.add(142, "Merengue");
            genreString.add(143, "Salsa");
            genreString.add(144, "Thrash metal");
            genreString.add(145, "Anime");
            genreString.add(146, "JPop");
            genreString.add(147, "Synthpop");
        }
        if (0 <= num && num < 148) {
            return genreString.get(num);
        } else {
            return "Genre non connu";
        }
    }

    private GestionnaireRepertoire lookupGestionnaireRepertoireBean() {
        try {
            Context c = new InitialContext();
            return (GestionnaireRepertoire) c.lookup("java:global/MusiqueANTOINE-MOPOLO/MusiqueANTOINE-MOPOLO-ejb/GestionnaireRepertoire!sessionbeans.GestionnaireRepertoire");
        } catch (NamingException ne) {
            Logger.getLogger(getClass().getName()).log(Level.SEVERE, "exception caught", ne);
            throw new RuntimeException(ne);
        }
    }

    private GestionnaireAlbum lookupGestionnaireAlbumBean() {
        try {
            Context c = new InitialContext();
            return (GestionnaireAlbum) c.lookup("java:global/MusiqueANTOINE-MOPOLO/MusiqueANTOINE-MOPOLO-ejb/GestionnaireAlbum!sessionbeans.GestionnaireAlbum");
        } catch (NamingException ne) {
            Logger.getLogger(getClass().getName()).log(Level.SEVERE, "exception caught", ne);
            throw new RuntimeException(ne);
        }
    }

    private GestionnaireArtiste lookupGestionnaireArtisteBean() {
        try {
            Context c = new InitialContext();
            return (GestionnaireArtiste) c.lookup("java:global/MusiqueANTOINE-MOPOLO/MusiqueANTOINE-MOPOLO-ejb/GestionnaireArtiste!sessionbeans.GestionnaireArtiste");
        } catch (NamingException ne) {
            Logger.getLogger(getClass().getName()).log(Level.SEVERE, "exception caught", ne);
            throw new RuntimeException(ne);
        }
    }

    private GestionnaireChanson lookupGestionnaireChansonBean() {
        try {
            Context c = new InitialContext();
            return (GestionnaireChanson) c.lookup("java:global/MusiqueANTOINE-MOPOLO/MusiqueANTOINE-MOPOLO-ejb/GestionnaireChanson!sessionbeans.GestionnaireChanson");
        } catch (NamingException ne) {
            Logger.getLogger(getClass().getName()).log(Level.SEVERE, "exception caught", ne);
            throw new RuntimeException(ne);
        }
    }

    
}
