/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package managedbeans;

import entities.Album;
import entities.Commentaire;
import entities.Utilisateur;
import javax.inject.Named;
import javax.enterprise.context.SessionScoped;
import java.io.Serializable;
import java.text.DateFormat;
import java.util.Calendar;
import java.util.Locale;
import javax.ejb.EJB;
import sessionbeans.GestionnaireCommentaire;

/**
 *
 * @author Maeva
 */
@Named(value = "commentaireMBean")
@SessionScoped
public class CommentaireMBean implements Serializable {

    @EJB
    private GestionnaireCommentaire gestionnaireCommentaire;
    private String texte_commentaire;
    private int note_commentaire;
    private Locale localeFR = new Locale("FR","fr");
    private Calendar calendrier = Calendar.getInstance(localeFR);
    private DateFormat format = DateFormat.getDateTimeInstance();
    private Commentaire comm_user_pour_album;
    
    /**
     * Creates a new instance of CommentaireMBean
     */
    public CommentaireMBean() {
    }
    
    public void envoieComm(Album a, Utilisateur u)
    {
        format.setCalendar(calendrier);
        Commentaire comm = new Commentaire(u, a, calendrier.getTime(), texte_commentaire, note_commentaire);
        gestionnaireCommentaire.creerCommentaire(new Commentaire(u, a, calendrier.getTime(), texte_commentaire, note_commentaire));
        this.note_commentaire=0;
        this.texte_commentaire="";
        setComm_user_pour_album(comm);
    }

    public String getTexte_commentaire() {
        return texte_commentaire;
    }

    public void setTexte_commentaire(String texte_commentaire) {
        this.texte_commentaire = texte_commentaire;
    }

    public int getNote_commentaire() {
        return note_commentaire;
    }

    public void setNote_commentaire(int note_commentaire) {
        this.note_commentaire = note_commentaire;
    }

    public Commentaire getComm_user_pour_album(Utilisateur u, Album a) {
        comm_user_pour_album = gestionnaireCommentaire.getCommentaireUserPourAlbum(a, u);
        return comm_user_pour_album;
    }

    public void setComm_user_pour_album(Commentaire comm_user_pour_album) {
        this.comm_user_pour_album = comm_user_pour_album;
    }
}
