/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package managedbeans;

import entities.Album;
import entities.Commentaire;
import entities.Playlist;
import entities.Utilisateur;
import javax.inject.Named;
import javax.enterprise.context.SessionScoped;
import java.io.Serializable;
import java.security.NoSuchAlgorithmException;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ejb.EJB;
import javax.faces.context.FacesContext;
import javax.servlet.http.HttpSession;
import sessionbeans.GestionnaireCommentaire;
import sessionbeans.GestionnairePlaylist;
import sessionbeans.GestionnaireUtilisateur;
import util.MD5;

/**
 *
 * @author Maeva
 */
@Named(value = "utilisateurMBean")
@SessionScoped
public class UtilisateurMBean implements Serializable {

    @EJB
    private GestionnaireUtilisateur gestionnaireUtilisateur;
    @EJB
    GestionnairePlaylist gestionnairePlaylist;
    private Utilisateur utilisateur;
    private String login;
    private String password;
    private boolean connected = false;
    private String message = "Veuillez vous identifier :";
    private String titreplaylist;
    // Utilisés pour le formulaire d'inscription d'un client
    private String nom; 
    private String prenom, email;
    private String messageInscription = "Inscription";
    private List<Playlist> playlistsUser;
    
    /**
     * Creates a new instance of UtilisateurMBean
     */
    public UtilisateurMBean() {
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public String getLogin() {
        return login;
    }

    public void setLogin(String login) {
        this.login = login;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public boolean isConnected() {
        return connected;
    }

    public void setConnected(boolean connected) {
        this.connected = connected;
    }

    public Utilisateur getUtilisateur() {
        return utilisateur;
    }

    public void setUtilisateur(Utilisateur utilisateur) {
        this.utilisateur = utilisateur;
    }
    
    
    
    public String inscriptionUser()
    {
        if(gestionnaireUtilisateur.getUserByEmail(email)== null)
        {
            utilisateur = new Utilisateur(nom, prenom, email, MD5.getEncodedPassword(password));
            gestionnaireUtilisateur.creerUtilisateur(utilisateur);
            connected = true;
            message = "Bienvenue, vous êtes connecté en tant que " + utilisateur.getUtilisateur_prenom() + " "+
                            utilisateur.getUtilisateur_nom() +" ! ";
            return "index";
        }
        else
        {
            messageInscription="Cet e-mail correspond déjà à un utilisateur inscrit.";
            return "inscription";
        }
    }

    public String deconnexion() {
        utilisateur=null;
        connected = false;
        FacesContext fc = FacesContext.getCurrentInstance();
        HttpSession session = (HttpSession) fc.getExternalContext().getSession(true);
        session.invalidate();
        message = "Veuillez vous identifier :";
        login=null;
        password=null;
        return "index";
    }

    public String creerPlaylist()
    {
        gestionnairePlaylist.creerPlaylist(new Playlist(titreplaylist, utilisateur));
        this.titreplaylist="";
        return "mesPlaylists";
    }
    
    public void checkLogin() {
        try {
            // Normalement à partir du login on devrait demander à l'ejb
            // gestionnaireUtilisateur de chercher dans la BD et retourner un 
            // utilisateur qu'on met dans la propriété utilisateur.
            // Là on simule...
            utilisateur = gestionnaireUtilisateur.getUserByEmail(login);
            if (utilisateur==null)
            {
                connected=false;
            }
            else if (MD5.testPassword(password, utilisateur.getUtilisateur_password()))
            {
                connected=true;
            }
            else
            {
                connected=false;
            }
            
            if (connected) {
                message = "Bienvenue, vous êtes connecté en tant que " + utilisateur.getUtilisateur_prenom() + " "+
                        utilisateur.getUtilisateur_nom() +" ! ";
            } else {
                message = "Mauvais login/password, veuillez recommencer !";
            }
        } catch (NoSuchAlgorithmException ex) {
            Logger.getLogger(UtilisateurMBean.class.getName()).log(Level.SEVERE, null, ex);
        }

    }

    public String getTitreplaylist() {
        return titreplaylist;
    }

    public void setTitreplaylist(String titreplaylist) {
        this.titreplaylist = titreplaylist;
    }

    public String getNom() {
        return nom;
    }

    public void setNom(String nom) {
        this.nom = nom;
    }

    public String getPrenom() {
        return prenom;
    }

    public void setPrenom(String prenom) {
        this.prenom = prenom;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getMessageInscription() {
        return messageInscription;
    }

    public void setMessageInscription(String messageInscription) {
        this.messageInscription = messageInscription;
    }

    public List<Playlist> getPlaylistsUser() {
       
         playlistsUser = gestionnairePlaylist.getPlaylistsUser(utilisateur);
        return playlistsUser;
    }

    public void setPlaylistsUser(List<Playlist> playlistsUser) {
        this.playlistsUser = playlistsUser;
    }

}
